#define GT_ID_ALL_URI  0
#define GT_ID_REF      1
#define GT_ID_POS      2
#define GT_ID_ALL      3
#define GT_ID_REF_URI 11
#define GT_ID_POS_URI 12

#define OPT_RM_GPT      0
#define OPT_RM_ENTRY    1
#define OPT_RM_MBR      2
#define OPT_RM_ALL      3

#define OPT_GCP_GPT     0
#define OPT_GCP_MBR     1
#define OPT_GCP_ALL     2

#define OPT_MCP_ADD     0
#define OPT_MCP_NADD    1
#define OPT_MCP_REPL    2
#define OPT_MCP_MOV     3

#define OPT_MRG_COPY    0
#define OPT_MRG_MOV     1

#define OPT_CMT_MBR      1
#define OPT_CMT_MBR_DEL 11

#define MAX_HDU_TRACKER 1000

#define fits_create_group       ffgtcr 
#define fits_insert_group       ffgtis 
#define fits_change_group       ffgtch 
#define fits_remove_group       ffgtrm 
#define fits_copy_group         ffgtcp 
#define fits_merge_groups       ffgtmg 
#define fits_compact_group      ffgtcm 
#define fits_verify_group       ffgtvf 
#define fits_open_group         ffgtop 
#define fits_add_group_member   ffgtam 
#define fits_get_num_members    ffgtnm 

#define fits_get_num_groups     ffgmng 
#define fits_open_member        ffgmop 
#define fits_copy_member        ffgmcp 
#define fits_transfer_member    ffgmtf 
#define fits_remove_member      ffgmrm

typedef struct _HDUtracker HDUtracker;

struct _HDUtracker
{
  int nHDU;

  char *filename[MAX_HDU_TRACKER];
  int  position[MAX_HDU_TRACKER];

  char *newFilename[MAX_HDU_TRACKER];
  int  newPosition[MAX_HDU_TRACKER];
};

int ffgtcr(fitsfile *fptr, char *grpname, int grouptype, int *status);

int ffgtis(fitsfile *fptr, char *grpname, int grouptype, int *status);

int ffgtch(fitsfile *gfptr, int grouptype, int *status);

int ffgtrm(fitsfile *gfptr, int rmopt, int *status);

int ffgtcp(fitsfile *infptr, fitsfile *outfptr, int cpopt, int *status);

int ffgtmg(fitsfile *infptr, fitsfile *outfptr, int mgopt, int *status);

int ffgtcm(fitsfile *gfptr, int cmopt, int *status);

int ffgtvf(fitsfile *gfptr, long *firstfailed, int *status);

int ffgtop(fitsfile *mfptr,int group,fitsfile **gfptr,int *status);

int ffgtam(fitsfile *gfptr, fitsfile *mfptr, int hdupos, int *status);

int ffgtnm(fitsfile *gfptr, long *nmembers, int *status);

int ffgmng(fitsfile *mfptr, long *nmembers, int *status);

int ffgmop(fitsfile *gfptr, long member, fitsfile **mfptr, int *status);

int ffgmcp(fitsfile *gfptr, fitsfile *mfptr, long member, int cpopt, 
	   int *status);

int ffgmtf(fitsfile *infptr, fitsfile *outfptr,	long member, int tfopt,	       
	   int *status);

int ffgmrm(fitsfile *fptr, long member, int rmopt, int *status);


/* functions used internally in the grouping convention module */

int ffgtdc(int grouptype, int xtensioncol, int extnamecol, int extvercol,
	   int positioncol, int locationcol, int uricol, char *ttype[],
	   char *tform[], int *ncols, int  *status);

int ffgtgc(fitsfile *gfptr, int *xtensionCol, int *extnameCol, int *extverCol,
	   int *positionCol, int *locationCol, int *uriCol, int *grptype,
	   int *status);

int ffgmul(fitsfile *mfptr, int rmopt, int *status);

int ffgmf(fitsfile *gfptr, char *xtension, char *extname, int extver,	   
	  int position,	char *location,	long *member, int *status);

int ffgtrmr(fitsfile *gfptr, HDUtracker *HDU, int *status);

int ffgtcpr(fitsfile *infptr, fitsfile *outfptr, int cpopt, HDUtracker *HDU,
	    int *status);

int fftsad(fitsfile *mfptr, HDUtracker *HDU, int *newPosition, 
	   char *newFileName);

int fftsud(fitsfile *mfptr, HDUtracker *HDU, int newPosition, 
	   char *newFileName);

void ffgtcn(char *filename);

void prepare_keyvalue(char *keyvalue);
